
import sys

if __name__ == "__main__":
    import configuration
    import UI
    import Data
    import SMTbuilder
    import re
    import math
    import subprocess

    print "Starting mNiBLoS..."
    
    rawData = UI.read()
    
    #print rawData.logic
    #print rawData.operation
    #print rawData.dataOperation
    
    SMTcode = "z3codes/smtcode"
    
    smtStructure = SMTbuilder.SMT(rawData, SMTcode)
    
    z3bin = configuration.Z3_LOCATION
    
    #print z3bin
    outputz3 = subprocess.check_output([z3bin, "-smt2", SMTcode])
    
    #outputz3.wait()
    
    processedOutput = outputz3.split("\n")
    
    if rawData.operation == "th":
    	if processedOutput[0] == "sat":
        	print "THE SPECIFIED FORMULA IS NOT A THEOREM"
        else:
        	print "THE SPECIFIED FORMULA IS A THEOREM"
    
    elif rawData.operation == "d":
        if processedOutput[0] == "sat":
        	print "THE FORMULA SPECIFIED IS NOT DERIVABLE FROM THE GIVEN SET OF PREMISES"
        else:
        	print "THE FORMULA SPECIFIED IS DERIVABLE FROM THE GIVEN SET OF PREMISES"
    else:
    	#satisfiability: need to read the model
        if processedOutput[0] == "unsat":
        	print "THE SET OF EQUATIONS IS NOT SATISFIABLE"
        else :
            #we read the reference values - constants - from product components
            productreferences = dict()
            line = 1
            for indexPList in smtStructure.data.constantsInProducts:
                c = smtStructure.data.constantsInProducts[indexPList][0]
                #productreferences[indexPlist] =self.data.constantsInProducts[indexPList][0]
                match = re.search('(\)\)) (.*)(\)\))', processedOutput[line])
                valueofc = match.group(2)
                productreferences[indexPList] = [(float(c[1]) - smtStructure.data.ordinalSum[indexPList][0][0])/(smtStructure.data.ordinalSum[indexPList][0][1] - smtStructure.data.ordinalSum[indexPList][0][0]) , "- "+valueofc]
                line = line + 1
                #we store the value already normalized, in order to simplify the later calculus

            print "A POSSIBLE MODEL FOR THE SET OF EQUATIONS IS THE FOLLOWING ONE:"
            print "The matrix of accessibility relations of the Kripke Structure is given by:"
                
            top = "   ||"
            bot = "---++"
            for i in range(smtStructure.nworlds):
                top = top + "   " + str(i)+ "   |"
                bot = bot + "------+"
            print top
            print bot
            for i in range(smtStructure.nworlds):
                relFromi = " "+str(i)+" ||"
                for j in range(smtStructure.nworlds):
                    #line = line + (smtStructure.nworlds * i) + j
                    #print "line: " + processedOutput[line]
                    match = re.search('(\)\)) (.*)(\)\))', processedOutput[line])
                    #print "match:" + match
                    comp = match.group(2)
                    line = line + 1

                    #print "line: " + processedOutput[line]
                    match = re.search('(\)\)) (.*)(\)\))', processedOutput[line])
                    readvalueVariable = match.group(2)
                    #print "comp: "+ comp
                    #print "readvalueVariable: " + readvalueVariable

                    if comp == "(- 1.0)":
                        #the value is a real in [0,1] -no preprocessing is needed
                        relFromi = relFromi + " " + str(readvalueVariable) +" |"
                        #varValues = varValues + readvalueVariable

                    else:
                        #print "comp: " + comp
                        #we are at a product component!
                        #first, observe if there is a reference for the values of this component.
                        #Otherwise, take as reference this one variable and an arbitrary value in the product componen -the medium point-
                        compr = int(float(comp))
                        if compr in productreferences:
                            #print "readvalueVariable: " + str(readvalueVariable)
                            #print "compr: "+ str(compr)
                            #print "smtStructure.data.ordinalSum[compr]: "
                            #print smtStructure.data.ordinalSum[compr]
                                        
                            relFromi = relFromi + " " + str(smtStructure.data.ordinalSum[compr][0][0]) + " + "
                            relFromi = relFromi + str(smtStructure.data.ordinalSum[compr][0][1] - smtStructure.data.ordinalSum[compr][0][0]) + " * "
                            relFromi = relFromi + str(productreferences[compr][0]) + " ^ (-" + str(readvalueVariable) + " / "+str(productreferences[compr][1])+")"
                        else:
                            productreferences[comp] = ["0.5", readvalueVariable]
                            relFromi = relFromi + str(smtStructure.data.ordinalSum[compr][0][0] + (smtStructure.data.ordinalSum[compr][0][1] - smtStructure.data.ordinalSum[compr][0][0])*0.5)
                        relFromi = relFromi + " |"

                    line = line + 1


                    # acces = re.search('(true)|(false)', processedOutput[line])
                    # valtrue = acces.group(1)
                    # valfalse = acces.group(2)
                    # if valtrue == "true":
                    #     relFromi = relFromi + " 1 |"
                    # elif valfalse == "false":
                    #     relFromi = relFromi + " 0 |"
                    # else :
                    #     print "ERROR IN THE READING"
                print relFromi
                print bot
        
#
#         
#            
#            
#            for j in range(len(self.data.ordinalSum)):
#                if self.data.ordinalSum[j][1] == "p":
#                    if self.data.constantsIn[j] != []:
#                        line = line + 1
#                        c = self.data.constantsIn[j][0]
#                        #the value assigned in -inf, 0) to c is:
#                        match = re.search('(\)\)) (.*)(\)\))', processedOutput[line])
#                        valueofc = match.group(2)
#                        productreferences[j] = [(float(c[1]) - self.data.ordinalSum[j][0][0])/(self.data.ordinalSum[j][0][1] - self.data.ordinalSum[j][0][0])) , valueofc]
#            

            #print "line: "+ str(line)
	#nvar = 0
	print "The tuple of values of each variable on each world (ordered from the value on world 0 on) is the following:"

        for v in smtStructure.data.variables:
		varValues = v + ": <"
                for i in range(smtStructure.nworlds):
			#line = line + 1
                    	#(nvar * smtStructure.nworlds) + i
                    	#print "line: "+ str(line)
                    	#the component line
                        #print "line: "+ processedOutput[line]
                    	match = re.search('(\)\)) (.*)(\)\))', processedOutput[line])
                    	comp = match.group(2)
                    	line = line + 1

                        #print "line: "+ processedOutput[line]
                    	#the value line
                    	#print "comp: "+comp
                    
                    	#REVISAR! LA SALIDA, SIENDO UN NUMERO REAL, VIENE MUCHAS VECES COMO NUMERO ALGEBRAICO - SOLUCION DE UNA FORMULA -
                    	#EL MATCHING DEL VALOR NO FUNCIONARA EN ESE CASO
                    	#print processedOutput[line]

                    	match = re.search('(\)\)) (.*)(\)\))', processedOutput[line])
                    	readvalueVariable = match.group(2)
                        #print readvalueVariable

                    	if comp == "(- 1.0)":
                        	#the value is a real in [0,1] -no preprocessing is needed
                        	varValues = varValues + readvalueVariable

                    	else:
                        	#we are at a product component!
                        	#first, observe if there is a reference for the values of this component.
                        	#Otherwise, take as reference this one variable and an arbitrary value in the product componen -the medium point-
                        	compr = int(float(comp))
                        	if compr in productreferences:
                                    #print "readvalueVariable: " + str(readvalueVariable)
                                    #print "compr: "+ str(compr)
                                    #print "smtStructure.data.ordinalSum[compr]: "
                                    #print smtStructure.data.ordinalSum[compr]
                                    
                                    varValues = varValues + " " + str(smtStructure.data.ordinalSum[compr][0][0]) + " + "
                                    varValues = varValues + str(smtStructure.data.ordinalSum[compr][0][1] - smtStructure.data.ordinalSum[compr][0][0]) + " * "
                                    varValues = varValues + str(productreferences[compr][0]) + " ^ (-" + str(readvalueVariable) + " / "+str(productreferences[compr][1])+")"
                        	else:
                                    productreferences[comp] = ["0.5", readvalueVariable]
                                    varValues = varValues + str(smtStructure.data.ordinalSum[compr][0][0] + (smtStructure.data.ordinalSum[compr][0][1] - smtStructure.data.ordinalSum[compr][0][0])*0.5)
                
                        
                    	if i != smtStructure.nworlds-1:
                        	varValues = varValues + ", "
                    	else:
                        	varValues = varValues + "> "
                        line = line +1
                print varValues
                
                #nvar = nvar + 1
